# Create Comments

> Source: https://truto.one/docs/api-reference/unified-ticketing-api/comments/create/

`POST /unified/ticketing/comments`

Resource: **Comments** · API: **Unified Ticketing API**

## Supported integrations

Dixa, Enchant, Gorgias, Help Scout, Hive, Jira, Pivotal Tracker, Quickbase for Project Management, Re:amaze, SolarWinds Service Desk, SurveySparrow Ticket Management, Todoist, Wrike, Zoho Projects

## Query parameters

- **`integrated_account_id`** _(string, required)_
  The ID of the integrated account to use for the request.
- **`truto_response_format`** _(string)_
  The format of the response. - `unified` returns the response with unified mappings applied. - `raw` returns the unprocessed, raw response from the remote API. - `normalized` applies the unified mappings and returns the data in a normalized format. - `stream` returns the response as a stream, which is ideal for transmitting large datasets, files, or binary data. Using streaming mode helps to efficiently handle large payloads or real-time data flows without requiring the entire data to be buffered in memory. Defaults to `unified`.
  Allowed: `unified`, `raw`, `normalized`, `stream`
- **`truto_ignore_remote_data`** _(boolean)_
  Excludes the `remote_data` attribute from the response.
- **`truto_exclude_fields`** _(array<string>)_
  Array of fields to exclude from the response.
- **`remote_query`** _(object)_
  Query parameters to pass to the underlying API without any transformations. Refer [this guide](https://truto.one/docs/api-reference/overview/querying#remote-query-parameters) to see how to structure the query parameters.
- **`ticket`** _(object)_
  Set either ticket or collections.
- **`ticket_id`** _(string)_
  The unique identifier for a ticket
- **`collections`** _(unknown)_
  Collection with type epic is required.
- **`organization`** _(object)_
- **`workspace`** _(unknown)_

## Request body

- **`body`** _(string)_
  One of body or html_body is required.
- **`author`** _(object)_
  The id of the user or contact who created the comment
  - **`id`** _(string, required)_
    Unique identifier of the user. Required if type is "user".
  - **`name`** _(string)_
    The name of the user or contact who created the comment
  - **`username`** _(string)_
    The username of the user or contact who created the comment
  - **`type`** _(string, required)_
    Type of the author
    Allowed: `user`, `contact`, `system`, `user`, `contact`
  - **`emails`** _(array<object>)_
    Required if type is set to "contact"
    - **`email`** _(string)_
      Email address of the contact
- **`is_internal`** _(boolean)_
  Set this value as true if the comment is internal note.
  Allowed: `true`
- **`html_body`** _(string)_
  One of body or html_body is required.
- **`contact`** _(unknown)_
  Required if creating an outbound reply.
- **`attachments`** _(array<object>)_
  Optional list of attachments to be attached to this thread.
  - **`id`** _(string)_
    The unique identifier for the attachment
  - **`file_name`** _(string, required)_
    The name of the file
  - **`file_url`** _(string)_
    The URL to download the attachment
  - **`content_type`** _(string, required)_
    The mime type of the file
  - **`uploaded_by`** _(object)_
    The user who uploaded the attachment
    - **`id`** _(string)_
      The user who uploaded the attachment
    - **`name`** _(string)_
      The user who uploaded the attachment
  - **`uploaded_by_type`** _(string)_
    The type of the user who uploaded the attachment
  - **`created_at`** _(string)_
    The time when the attachment was created
  - **`data`** _(string, required)_
    The base64 encoded data of the file
- **`channel`** _(object)_
  The medium through which the comment was sent.
  - **`id`** _(string)_
    The unique identifier for the channel
  - **`name`** _(string)_
    The name of the channel
  - **`type`** _(string)_
    The type of the channel
- **`created_at`** _(string)_
  The date and time when the comment was created
- **`receiver`** _(object)_
  The id of the user or contact who is receiving the comment
  - **`id`** _(string, required)_
    The id of the user or contact who receiving the comment
  - **`name`** _(string)_
    The name of the user or contact who receiving the comment
  - **`type`** _(string, required)_
    Type of the receiver
    Allowed: `user`, `contact`, `system`
- **`subject`** _(string)_
  The subject of the comment
- **`draft`** _(boolean)_
  If set to true, a draft reply is created.
- **`contact_id`** _(string)_
  The id of the contact who created the comment.
- **`user_id`** _(string)_
  ID of the user who is adding the thread. The resource owner is the default when not set.
- **`imported`** _(boolean)_
  The imported field enables thread to be created for historical purposes (i.e. if moving from a different platform, you can import your history). When imported is set to true, no outgoing emails or notifications will be generated.
- **`status`** _(string)_
  Use this field to change conversation status when adding a thread. If not explicitly set, a reply thread will reactivate the conversation.
- **`cc`** _(array<string>)_
  Collection of strings representing email addresses.
- **`bcc`** _(array<string>)_
  Collection of strings representing email addresses.
- **`ticket`** _(object)_
  Either ticket or collections is required.
  - **`id`** _(string, required)_
    The unique identifier for a ticket
- **`custom_fields`** _(unknown)_
- **`is_private`** _(boolean)_
  Whether the comment is private or not
- **`collections`** _(unknown)_
  Either ticket or collections is required.
- **`remote_data`** _(object)_
  Any additional data that should be passed as part of the request body. This data is not transformed by Truto and is passed as is to the remote API.

## Response body

- **`id`** _(string, required)_
  The unique identifier for a comment
- **`author`** _(object)_
  The id of the user or contact who created the comment
  - **`id`** _(string, required)_
    The id of the user or contact who created the comment
  - **`name`** _(string)_
    The name of the user or contact who created the comment
  - **`username`** _(string)_
    The username of the user or contact who created the comment
  - **`type`** _(string, required)_
    Type of the author
    Allowed: `user`, `contact`, `system`
- **`receiver`** _(object)_
  The id of the user or contact who is receiving the comment
  - **`id`** _(string, required)_
    The id of the user or contact who receiving the comment
  - **`name`** _(string)_
    The name of the user or contact who receiving the comment
  - **`type`** _(string, required)_
    Type of the receiver
    Allowed: `user`, `contact`, `system`
- **`body`** _(string)_
  The body of the comment
- **`html_body`** _(string)_
  The body of the comment in HTML format
- **`ticket`** _(object)_
  The ticket to which the comment belongs
  - **`id`** _(string, required)_
    The unique identifier for a ticket
- **`attachments`** _(array<object>)_
  The attachments of the comment
  - **`id`** _(string)_
    The unique identifier for the attachment
  - **`file_name`** _(string)_
    The attachment's name.
  - **`file_url`** _(string)_
    The URL to download the attachment
  - **`content_type`** _(string)_
    The content type of the attachment
  - **`uploaded_by`** _(object)_
    The user who uploaded the attachment
    - **`id`** _(string)_
      The user who uploaded the attachment
    - **`name`** _(string)_
      The user who uploaded the attachment
  - **`uploaded_by_type`** _(string)_
    The type of the user who uploaded the attachment
  - **`created_at`** _(string)_
    The time when the attachment was created
- **`is_internal`** _(boolean)_
  Whether the comment is internal. True for internal notes left by users.
- **`is_private`** _(boolean)_
  Whether the comment is private or not
- **`channel`** _(object)_
  The medium through which the comment was sent.
  - **`id`** _(string)_
    The unique identifier for the channel
  - **`name`** _(string)_
    The name of the channel
  - **`type`** _(string)_
    The type of the channel
- **`created_at`** _(string)_
  The date and time when the comment was created
- **`updated_at`** _(string)_
  The date and time when the comment was updated
- **`etag`** _(string)_
  The unique identifier for the specific version of the resource.
- **`remote_data`** _(object)_
  Raw data returned from the remote API call.

## Code examples

### curl

```bash
curl -X POST 'https://api.truto.one/unified/ticketing/comments?integrated_account_id=<integrated_account_id>' \
  -H 'Authorization: Bearer <your_api_token>' \
  -H 'Content-Type: application/json' \
  -d '{
  "body": "your_body",
  "author": {},
  "is_internal": true,
  "html_body": "your_html_body",
  "attachments": [],
  "channel": {},
  "created_at": "your_created_at",
  "receiver": {},
  "subject": "your_subject",
  "draft": true,
  "contact_id": "your_contact_id",
  "user_id": "your_user_id",
  "imported": true,
  "status": "your_status",
  "cc": [],
  "bcc": [],
  "ticket": {},
  "is_private": true,
  "remote_data": {}
}'
```

### JavaScript

```javascript
const integratedAccountId = '<integrated_account_id>';

const body = {
  "body": "your_body",
  "author": {},
  "is_internal": true,
  "html_body": "your_html_body",
  "attachments": [],
  "channel": {},
  "created_at": "your_created_at",
  "receiver": {},
  "subject": "your_subject",
  "draft": true,
  "contact_id": "your_contact_id",
  "user_id": "your_user_id",
  "imported": true,
  "status": "your_status",
  "cc": [],
  "bcc": [],
  "ticket": {},
  "is_private": true,
  "remote_data": {}
};

const response = await fetch(`https://api.truto.one/unified/ticketing/comments?integrated_account_id=${integratedAccountId}`, {
  method: 'POST',
  headers: {
    'Authorization': 'Bearer <your_api_token>',
    'Content-Type': 'application/json',
  },
  body: JSON.stringify(body),
});

const data = await response.json();
console.log(data);
```

### Python

```python
import requests

url = "https://api.truto.one/unified/ticketing/comments"
headers = {
    "Authorization": "Bearer <your_api_token>",
    "Content-Type": "application/json",
}
params = {
    "integrated_account_id": "<integrated_account_id>"
}
payload = {
    "body": "your_body",
    "author": {},
    "is_internal": True,
    "html_body": "your_html_body",
    "attachments": [],
    "channel": {},
    "created_at": "your_created_at",
    "receiver": {},
    "subject": "your_subject",
    "draft": True,
    "contact_id": "your_contact_id",
    "user_id": "your_user_id",
    "imported": True,
    "status": "your_status",
    "cc": [],
    "bcc": [],
    "ticket": {},
    "is_private": True,
    "remote_data": {}
}

response = requests.post(url, headers=headers, params=params, json=payload)
print(response.json())
```

### Truto TS SDK

```typescript
import Truto from '@truto/truto-ts-sdk';

const truto = new Truto({
  token: '<your_api_token>',
});

const result = await truto.unifiedApi.create(
  'ticketing',
  'comments',
  {
  "body": "your_body",
  "author": {},
  "is_internal": true,
  "html_body": "your_html_body",
  "attachments": [],
  "channel": {},
  "created_at": "your_created_at",
  "receiver": {},
  "subject": "your_subject",
  "draft": true,
  "contact_id": "your_contact_id",
  "user_id": "your_user_id",
  "imported": true,
  "status": "your_status",
  "cc": [],
  "bcc": [],
  "ticket": {},
  "is_private": true,
  "remote_data": {}
},
  { integrated_account_id: '<integrated_account_id>' }
);

console.log(result);
```

### Truto Python SDK

```python
import asyncio
from truto_python_sdk import TrutoApi

truto_api = TrutoApi(token="<your_api_token>")

async def main():
    result = await truto_api.unified_api.create(
        "ticketing",
        "comments",
        {
        "body": "your_body",
        "author": {},
        "is_internal": True,
        "html_body": "your_html_body",
        "attachments": [],
        "channel": {},
        "created_at": "your_created_at",
        "receiver": {},
        "subject": "your_subject",
        "draft": True,
        "contact_id": "your_contact_id",
        "user_id": "your_user_id",
        "imported": True,
        "status": "your_status",
        "cc": [],
        "bcc": [],
        "ticket": {},
        "is_private": True,
        "remote_data": {}
},
        {"integrated_account_id": "<integrated_account_id>"}
    )
    print(result)

asyncio.run(main())
```
